<template>
  <div class="container">
    <div v-if="isLoggedIn" class="flex">
      <nuxt-link to="/dashboard" class="avatar">
        <div class="avatar__image" :style="{backgroundImage: `url(${avatar})`}" v-if="!collapsed"></div>
      </nuxt-link>
      <nuxt-link to="/cart">
        <Badge :value="String($store.getters['cart/getCount'])" :show="!!$store.getters['cart/getCount']">
          <Button type="text" round :color="buttonColor" size="sm" class="cart" :light="light">
            <template #icon>
              <cart />
            </template>
          </Button>
        </Badge>
      </nuxt-link>
      <Button type="text" round :color="buttonColor" size="sm"  v-if="!collapsed" :light="light" @click.native="logout">
        <template #icon>
          <logout  class="logout"/>
        </template>
      </Button>
    </div>
    <div v-else class="flex">
      <nuxt-link to="/register" class="link" v-ripple>ثبت نام</nuxt-link>
      <nuxt-link to="/login" class="link" v-ripple>ورود</nuxt-link>
    </div>
  </div>
</template>

<script>
import Button from '@/components/base/Button';
import Badge from '@/components/base/Badge';
import cart from "@/assets/svgs/cart.svg";
import logout from "@/assets/svgs/logout.svg";

export default {
  name: "TheHeaderAauth",
  components: {
    Button,
    cart,
    logout,
    Badge
  },
  props: {
    isLoggedIn: {
      type: Boolean,
      required: true
    },
    avatar: {
      type: String,
      default: "/images/profile.png"
    },
    collapsed: {
      type: Boolean,
      required: true
    },
    light: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    logout() {
      this.$store.dispatch("auth/logout").then(response => {
        this.$store.dispatch('notifications/push', {
          message: 'با موفقیت خارج شدید!',
          type: 'success',
          light: true,
          timeout: 2000
        });
      });
    }
  },
  computed: {
    buttonColor() {
      return this.light ? 'dark' : 'white';
    }
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

.container 
  display flex
  align-items stretch

.flex 
  display flex
  align-items center

.sign-icon 
  fill $white
  margin $header-sign-icon-margin

.link 
  padding $header-link-padding
  transition all 0.2s
  display block
  position relative
  align-self stretch
  display flex
  align-items center
  &:hover 
    color: $primary

.avatar 
  margin $header-avatar-margin
  &__image
    width $header-avatar-size
    height $header-avatar-size
    position relative
    background-size cover
    background-position center
    border-radius $header-avatar-border-radius
    &:hover
      cursor pointer

.cart 
  margin $header-cart-margin

.logout 
  transform rotate(180deg)
</style>

